program Laufwerksinfo; uses dos; { XL-Version 15.12.97 - max 10GB layouted }
{ by Eric Auer, eric@coli.uni-sb.de, released into public domain 11/2002 }
{ Cdrom-Bonus 9/1998 FAT32 5/2007 }
{ C-Z and auto-filter 2/2000, plus unit 2^10 byte, kilo=2^10 instead of 10^3 }
type SpaceRec = record
  header, secperclustadj, bypersec, freeclustadj: Longint;  
  totalclustadj, freesect, totalsect, freeclust: Longint;
  totalclust, res1, res2: Longint;
end;
const max = 'Z';        { CONFIGURE HERE: highest drive letter }
      su = ord('A')-1;
      showskip = false; { CONFIGURE HERE: skipping behaviour }
      skipram = true;   { CONFIGURE HERE: skipping behaviour }
var x: char;
    f,s,u,f2,s2,u2: longint;
    sr: SearchRec; {0 now 1.. A..}
    reg: registers;
    where: String;
    spacedata: SpaceRec;
    xshift: integer;

{ show a value in kB units as nnnnn.nnn MB }
procedure wri_l(xx:longint); var stelle,decis:longint; begin
   stelle := xx shr 10; if stelle=0 then stelle:=1;
   decis := (125*(xx mod 1024)) shr 7; { decimals, scale 1024 to 1000 }
   while stelle<10000 do
     begin stelle:=stelle*10; write(' '); end; { pad to 5 digits before the . }
   write((xx shr 10),'.');
   stelle := decis; if stelle=0 then stelle:=1;
   while stelle<100 do
     begin stelle:=stelle*10; write('0'); end; { pad to 3 digits after the . }
   write(decis);
   write(' MB');
end;

procedure wri_inf; begin
  write(output, '',x,': [',sr.name,'] ');
  wri_l(u); write(' used, (');
  wri_l(f); write(' of ');
  wri_l(s); writeln(' free)');
end;


begin
  f2:=0; s2:=0; u2:=0;

  write('VolInfXL by AuerSoft 1997-2000/2007, using MB=',1 shl 20,' ');

  reg.ax := $1500;
  reg.bx := 0;
  intr($2f, reg);
  case reg.bl of
    0: writeln('[ No CDROM ]');
    1: writeln('[ Remote CD-ROM is ',chr($41+reg.cl),': ]');
    else writeln ('CDROM are ',chr($41+reg.cl),': to ',chr(su+reg.cl+reg.bl),':');
  end; {case}

  if not(showskip) then write('Ignoring drives with no label ');
  if not(showskip) and skipram then write('or label MS-RAMDRIVE ');
  if skipram and showskip then write('Ignoring drives with label MS-RAMDRIVE ');
  writeln;


  for x:='C' to max do begin
    findfirst(''+x+':\*.*',VolumeID,sr);
    if DosError<>0 then begin
      if showskip then writeln('No Label on drive ',x,':')
    end else begin
      sr.name[9]:=sr.name[10];  sr.name[10]:=sr.name[11];
      sr.name[11]:=sr.name[12]; sr.name[12]:=' ';
      if sr.name[0]>#8 then dec(sr.name[0]);        { remove '.' of extension }
      while sr.name[0]<#11 do sr.name:=sr.name+'.'; { pad with '.' full length }

      if (sr.name<>'MS-RAMDRIVE') or not(skipram) then begin
        s:=0;
        reg.ax := $7300; reg.dx := 1+(ord(x)-ord('A')); reg.cx := 1;
        intr($21,reg);
        if (reg.ax<>$7300) then begin { fat32 found, use get ext free space }
          where := x+':\'+chr(0);
          spacedata.header := $30; { actually word 30, word 0 }
          spacedata.freesect := 0;
          spacedata.totalsect := 0;
          reg.ds := Seg(where); reg.dx := Ofs(where)+1; { after size-count byte }
          reg.es := Seg(spacedata); reg.di := Ofs(spacedata);
          reg.cx := $30;
          reg.ax := $7303;
          intr($21, reg); { buffer [8]d = bytes/sector [$14]d = free sectors }
          { buffer [4] sect/clust adj [$c] free clust [$10] total clust }
          { [$18] total sect [$1c] free clust [$20] total clust [$24]q resvd }
          if (((reg.flags and fcarry) = 0) and (spacedata.bypersec <> 0)) then begin
            xshift := 1; { for example dosemu redir uses 1024 bytes per sector }
            while (spacedata.bypersec<512) do begin
              spacedata.bypersec := spacedata.bypersec shl 1;
              xshift := xshift + 1;
            end;
            while (spacedata.bypersec>512) do begin
              spacedata.bypersec := spacedata.bypersec shr 1;
              xshift := xshift - 1;
            end;
            if (xshift < 0) then begin { convert to kilobytes }
              f := spacedata.freesect shl (-xshift);
              s := spacedata.totalsect shl (-xshift);
            end else begin
              f := spacedata.freesect shr xshift;
              s := spacedata.totalsect shr xshift;
            end; { shift }
          end; { no carry }
        end; { fat32 supported }
        if (s < 1) then begin
          f := diskfree(ord(x)-su) shr 10;
          s := disksize(ord(x)-su) shr 10;
        end;
        u:=s-f;
        f2:=f2+f; s2:=s2+s; u2:=u2+u;
        wri_inf;
      end; { Use this drive (Ramdrive might be skipped) }
    end; { Label found }
  end; { for }

  x:='#'; sr.name:='SUMMARY:   ';
  f:=f2; s:=s2; u:=u2;
  wri_inf;

end.
